﻿<%@ Page Language="VB" MasterPageFile="~/vfpbook.master" AutoEventWireup="false" CodeFile="Default.aspx.vb" Inherits="_Default" %>

<asp:Content ID="Content1" ContentPlaceHolderID="head" Runat="Server">
</asp:Content>
<asp:Content ID="Content4" ContentPlaceHolderID="content_pane" Runat="Server">
   <asp:Label ID="Label3" runat="server" 
      Text="Выберите из списка страну потребителя:"></asp:Label>
   <br />
   <asp:DropDownList ID="DropDownList1" runat="server" AutoPostBack="True" 
      DataSourceID="vfpCountries" DataTextField="country" 
      DataValueField="country" Width="200px">
   </asp:DropDownList>
   <br />
   <br />
   <asp:GridView ID="GridView1" runat="server" AllowPaging="True" 
      AllowSorting="True" AutoGenerateColumns="False" DataKeyNames="customerid" 
      DataSourceID="vfpCustomers" BackColor="White" BorderColor="#CC9966" 
      BorderStyle="None" BorderWidth="1px" CellPadding="4">
      <FooterStyle BackColor="#FFFFCC" ForeColor="#330099" />
      <RowStyle BackColor="White" ForeColor="#330099" />
      <Columns>
         <asp:CommandField ShowDeleteButton="True" ShowEditButton="True" 
            ButtonType="Button" ShowInsertButton="True" CancelText="Отмена" 
            DeleteText="Удалить" EditText="Изменить" InsertText="Вставить" 
            NewText="Создать" UpdateText="Обновить" />
         <asp:BoundField DataField="customerid" HeaderText="customerid" ReadOnly="True" 
            SortExpression="customerid" Visible="False" />
         <asp:BoundField DataField="companyname" HeaderText="Компания" 
            SortExpression="companyname" />
         <asp:BoundField DataField="contactname" HeaderText="Контактное лицо" 
            SortExpression="contactname" />
         <asp:BoundField DataField="contacttitle" HeaderText="Приветствие" 
            SortExpression="contacttitle" Visible="False" />
         <asp:BoundField DataField="address" HeaderText="Адрес" 
            SortExpression="address" />
         <asp:BoundField DataField="city" HeaderText="Город" SortExpression="city" />
         <asp:BoundField DataField="region" HeaderText="Район" 
            SortExpression="region" Visible="False" />
         <asp:BoundField DataField="phone" HeaderText="Телефон" SortExpression="phone" 
            Visible="False" />
         <asp:BoundField DataField="postalcode" HeaderText="Почтовый индекс" 
            SortExpression="postalcode" />
         <asp:BoundField DataField="country" HeaderText="Страна" 
            SortExpression="country" />
         <asp:BoundField DataField="fax" HeaderText="Факс" SortExpression="fax" 
            Visible="False" />
      </Columns>
      <PagerStyle BackColor="#FFFFCC" ForeColor="#330099" HorizontalAlign="Center" />
      <SelectedRowStyle BackColor="#FFCC66" Font-Bold="True" ForeColor="#663399" />
      <HeaderStyle BackColor="#990000" Font-Bold="True" ForeColor="#FFFFCC" />
   </asp:GridView>
   <asp:SqlDataSource ID="vfpCustomers" runat="server" 
      ConflictDetection="CompareAllValues" 
      ConnectionString="<%$ ConnectionStrings:vfp_NorthWind %>" 
      DeleteCommand="DELETE FROM Customers WHERE customerid = ? AND companyname = ? AND contactname = ? AND contacttitle = ? AND address = ? AND city = ? AND region = ? AND postalcode = ? AND country = ? AND phone = ? AND fax = ?" 
      InsertCommand="INSERT INTO Customers (customerid, companyname, contactname, contacttitle, address, city, region, postalcode, country, phone, fax) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)" 
      OldValuesParameterFormatString="original_{0}" 
      ProviderName="<%$ ConnectionStrings:vfp_NorthWind.ProviderName %>" 
      SelectCommand="SELECT * FROM Customers WHERE (country = ?)" 
      UpdateCommand="UPDATE Customers SET companyname = ?, contactname = ?, contacttitle = ?, address = ?, city = ?, region = ?, postalcode = ?, country = ?, phone = ?, fax = ? WHERE customerid = ? ">
      <SelectParameters>
         <asp:ControlParameter ControlID="DropDownList1" DefaultValue="USA" 
            Name="country" PropertyName="SelectedValue" Type="String" />
      </SelectParameters>
      <DeleteParameters>
         <asp:Parameter Name="original_customerid" Type="String" />
         <asp:Parameter Name="original_companyname" Type="String" />
         <asp:Parameter Name="original_contactname" Type="String" />
         <asp:Parameter Name="original_contacttitle" Type="String" />
         <asp:Parameter Name="original_address" Type="String" />
         <asp:Parameter Name="original_city" Type="String" />
         <asp:Parameter Name="original_region" Type="String" />
         <asp:Parameter Name="original_postalcode" Type="String" />
         <asp:Parameter Name="original_country" Type="String" />
         <asp:Parameter Name="original_phone" Type="String" />
         <asp:Parameter Name="original_fax" Type="String" />
      </DeleteParameters>
      <UpdateParameters>
         <asp:Parameter Name="companyname" Type="String" />
         <asp:Parameter Name="contactname" Type="String" />
         <asp:Parameter Name="contacttitle" Type="String" />
         <asp:Parameter Name="address" Type="String" />
         <asp:Parameter Name="city" Type="String" />
         <asp:Parameter Name="region" Type="String" />
         <asp:Parameter Name="postalcode" Type="String" />
         <asp:Parameter Name="country" Type="String" />
         <asp:Parameter Name="phone" Type="String" />
         <asp:Parameter Name="fax" Type="String" />
         <asp:Parameter Name="original_customerid" Type="String" />
         <asp:Parameter Name="original_companyname" Type="String" />
         <asp:Parameter Name="original_contactname" Type="String" />
         <asp:Parameter Name="original_contacttitle" Type="String" />
         <asp:Parameter Name="original_address" Type="String" />
         <asp:Parameter Name="original_city" Type="String" />
         <asp:Parameter Name="original_region" Type="String" />
         <asp:Parameter Name="original_postalcode" Type="String" />
         <asp:Parameter Name="original_country" Type="String" />
         <asp:Parameter Name="original_phone" Type="String" />
         <asp:Parameter Name="original_fax" Type="String" />
      </UpdateParameters>
      <InsertParameters>
         <asp:Parameter Name="customerid" Type="String" />
         <asp:Parameter Name="companyname" Type="String" />
         <asp:Parameter Name="contactname" Type="String" />
         <asp:Parameter Name="contacttitle" Type="String" />
         <asp:Parameter Name="address" Type="String" />
         <asp:Parameter Name="city" Type="String" />
         <asp:Parameter Name="region" Type="String" />
         <asp:Parameter Name="postalcode" Type="String" />
         <asp:Parameter Name="country" Type="String" />
         <asp:Parameter Name="phone" Type="String" />
         <asp:Parameter Name="fax" Type="String" />
      </InsertParameters>
   </asp:SqlDataSource>
<br />
   <asp:SqlDataSource ID="vfpCountries" runat="server" 
      ConnectionString="<%$ ConnectionStrings:vfp_NorthWind %>" 
      ProviderName="<%$ ConnectionStrings:vfp_NorthWind.ProviderName %>" 
      SelectCommand="SELECT DISTINCT country FROM Customers" />
   <br />
   <br />
   <br />
      
</asp:Content>

