
#DEFINE wiaIDUnknown   "{00000000-0000-0000-0000-000000000000}"   && Unknown ID.
#DEFINE wiaAnyDeviceID   "*"   && DeviceID for any Device.
#DEFINE wiaFormatBMP   "{B96B3CAB-0728-11D3-9D7B-0000F81EF32E}"   && FormatID for the BMP (Windows bitmap) format.
#DEFINE wiaFormatPNG   "{B96B3CAF-0728-11D3-9D7B-0000F81EF32E}"   && FormatID for the PNG (Portable Network Graphics) format.
#DEFINE wiaFormatGIF   "{B96B3CB0-0728-11D3-9D7B-0000F81EF32E}"   && FormatID for the GIF (Graphics Interchange Format) format.
#DEFINE wiaFormatJPEG   "{B96B3CAE-0728-11D3-9D7B-0000F81EF32E}"   && FormatID for the JPEG (Joint Photographic Experts Group) format.
#DEFINE wiaFormatTIFF   "{B96B3CB1-0728-11D3-9D7B-0000F81EF32E}"   && FormatID for the TIFF (Tag Image File Format) format.
#DEFINE wiaEventDeviceConnected   "{A28BBADE-64B6-11D2-A231-00C04FA31809}"   && EventID for Device Connected. This event fires when a WIA hardware device is connected to the user's computer or started.
#DEFINE wiaEventDeviceDisconnected   "{143E4E83-6497-11D2-A231-00C04FA31809}"   && EventID for Device Disconnected. This event fires when a WIA hardware device is disconnected from the user's computer or stopped.
#DEFINE wiaEventItemCreated   "{4C8F4EF5-E14F-11D2-B326-00C04F68CE61}"   && EventID for Item Created. This event fires when an item is added to a WIA Device.
#DEFINE wiaEventItemDeleted   "{1D22A559-E14F-11D2-B326-00C04F68CE61}"   && EventID for Item Deleted. This event fires when an item is deleted from a WIA Device.
#DEFINE wiaEventScanImage   "{A6C5A715-8C6E-11D2-977A-0000F87A926F}"   && EventID for Scan Image. This event fires when the image button on a scanner is pressed.
#DEFINE wiaEventScanPrintImage   "{B441F425-8C6E-11D2-977A-0000F87A926F}"   && EventID for Scan Print Image. This event fires when the print button on a scanner is pressed.
#DEFINE wiaEventScanFaxImage   "{C00EB793-8C6E-11D2-977A-0000F87A926F}"   && EventID for Scan Fax Image. This event fires when the FAX button on a scanner is pressed.
#DEFINE wiaEventScanOCRImage   "{9D095B89-37D6-4877-AFED-62A297DC6DBE}"   && EventID for Scan OCR Image. This event fires when the OCR button on a scanner is pressed.
#DEFINE wiaEventScanEmailImage   "{C686DCEE-54F2-419E-9A27-2FC7F2E98F9E}"   && EventID for Scan Email Image. This event fires when the email button on a scanner is pressed.
#DEFINE wiaEventScanFilmImage   "{9B2B662C-6185-438C-B68B-E39EE25E71CB}"   && EventID for Scan Film Image. This event fires when the film button on a scanner is pressed.
#DEFINE wiaEventScanImage2   "{FC4767C1-C8B3-48A2-9CFA-2E90CB3D3590}"   && EventID for Scan Image 2. This event fires when the second image button on a scanner is pressed.
#DEFINE wiaEventScanImage3   "{154E27BE-B617-4653-ACC5-0FD7BD4C65CE}"   && EventID for Scan Image 3. This event fires when the third image button on a scanner is pressed.
#DEFINE wiaEventScanImage4   "{A65B704A-7F3C-4447-A75D-8A26DFCA1FDF}"   && EventID for Scan Image 4. This event fires when the fourth image button on a scanner is pressed.
#DEFINE wiaCommandSynchronize   "{9B26B7B2-ACAD-11D2-A093-00C04F72DC3C}"   && CommandID for Synchronize. Causes the device's driver to synchronize cached items with the hardware device.
#DEFINE wiaCommandTakePicture   "{AF933CAC-ACAD-11D2-A093-00C04F72DC3C}"   && CommandID for Take Picture. Causes a WIA device to acquire an image.
#DEFINE wiaCommandDeleteAllItems   "{E208C170-ACAD-11D2-A093-00C04F72DC3C}"   && CommandID for Delete All Items. Tells the device to delete all items that can be deleted from the device.
#DEFINE wiaCommandChangeDocument   "{04E725B0-ACAE-11D2-A093-00C04F72DC3C}"   && CommandID for Change Document. Used for document scanners. Causes the scanner to load the next page in its document handler.
#DEFINE wiaCommandUnloadDocument   "{1F3B3D8E-ACAE-11D2-A093-00C04F72DC3C}"   && CommandID for Unload Document. Used for document scanners. Tells the device to unload all remaining pages in its document handler.
#DEFINE UnspecifiedSubType   0   && This property has no subtype.
#DEFINE RangeSubType   1   && This property takes a range of values from SubTypeMin to SubTypeMax in SubTypeStep increments.
#DEFINE ListSubType   2   && This property takes one of a list of values from SubTypeValues.
#DEFINE FlagSubType   3   && This property takes a flag composed of bits listed in SubTypeValues. Flag values are combined using the OR operation.
#DEFINE UnspecifiedDeviceType   0   && The Device type is unknown.
#DEFINE ScannerDeviceType   1   && The Device is a scanner.
#DEFINE CameraDeviceType   2   && The Device is a camera.
#DEFINE VideoDeviceType   3   && The Device provides streaming video.
#DEFINE FreeItemFlag   0   && The item is uninitialized or has been deleted.
#DEFINE ImageItemFlag   1   && The item is an image file. Only valid for items that also have the FileItemFlag flag set.
#DEFINE FileItemFlag   2   && The item is a file.
#DEFINE FolderItemFlag   4   && The item is a folder.
#DEFINE RootItemFlag   8   && Identifies the root item in the device.
#DEFINE AnalyzeItemFlag   16   && This item supports the Analyze method.
#DEFINE AudioItemFlag   32   && The item is an audio file. Only valid for items that also have the FileItemFlag flag set.
#DEFINE DeviceItemFlag   64   && The item represents a connected device.
#DEFINE DeletedItemFlag   128   && The item is marked as deleted.
#DEFINE DisconnectedItemFlag   256   && The item represents a disconnected device.
#DEFINE HPanoramaItemFlag   512   && The item represents a horizontal panoramic image.
#DEFINE VPanoramaItemFlag   1024   && The item represents a vertical panoramic image.
#DEFINE BurstItemFlag   2048   && Images in this folder were taken in a continuous time sequence. Only valid for items that also have the FolderItemFlag flag set.
#DEFINE StorageItemFlag   4096   && The item represents a storage medium.
#DEFINE TransferItemFlag   8192   && The item can be transferred.
#DEFINE GeneratedItemFlag   16384   && This item was created, and does not correspond to an item in a device.
#DEFINE HasAttachmentsItemFlag   32768   && The item has file attachments.
#DEFINE VideoItemFlag   65536   && The item represents streaming video.
#DEFINE RemovedItemFlag   -2147483648   && The item has been removed from the device.
#DEFINE UnsupportedPropertyType   0   && The value of the property is an unsupported type.
#DEFINE BooleanPropertyType   1   && The value of the property is a Boolean.
#DEFINE BytePropertyType   2   && The value of the property is a Byte.
#DEFINE IntegerPropertyType   3   && The value of the property is an Integer.
#DEFINE UnsignedIntegerPropertyType   4   && The value of the property is returned as a non-negative Integer.
#DEFINE LongPropertyType   5   && The value of the property is a Long.
#DEFINE UnsignedLongPropertyType   6   && The value of the property is returned as a non-negative Long.
#DEFINE ErrorCodePropertyType   7   && The value of the property is returned as a Long.
#DEFINE LargeIntegerPropertyType   8   && The value of the property is a Large Integer returned as a truncated Long.
#DEFINE UnsignedLargeIntegerPropertyType   9   && The value of the property is returned as a truncated non-negative Long.
#DEFINE SinglePropertyType   10   && The value of the property is a Single.
#DEFINE DoublePropertyType   11   && The value of the property is a Double.
#DEFINE CurrencyPropertyType   12   && The value of the property is a Currency.
#DEFINE DatePropertyType   13   && The value of the property is a Date.
#DEFINE FileTimePropertyType   14   && The value of the property is returned as a Date.
#DEFINE ClassIDPropertyType   15   && The value of the property is returned as a String.
#DEFINE StringPropertyType   16   && The value of the property is a String.
#DEFINE ObjectPropertyType   17   && The value of the property is an Object.
#DEFINE HandlePropertyType   18   && The value of the property is returned as a Variant.
#DEFINE VariantPropertyType   19   && The value of the property is a Variant.
#DEFINE VectorOfBooleansPropertyType   101   && The value of the property is a Vector object containing Boolean elements.
#DEFINE VectorOfBytesPropertyType   102   && The value of the property is a Vector object containing Byte elements.
#DEFINE VectorOfIntegersPropertyType   103   && The value of the property is a Vector object containing Integer elements.
#DEFINE VectorOfUnsignedIntegersPropertyType   104   && The value of the property is returned as a Vector object containing non-negative Integer elements.
#DEFINE VectorOfLongsPropertyType   105   && The value of the property is a Vector object containing Long elements.
#DEFINE VectorOfUnsignedLongsPropertyType   106   && The value of the property is returned as a Vector object containing non-negative Long elements.
#DEFINE VectorOfErrorCodesPropertyType   107   && The value of the property is returned as a Vector object containing Long elements.
#DEFINE VectorOfLargeIntegersPropertyType   108   && The value of the property is returned as a Vector object containing truncated Long elements.
#DEFINE VectorOfUnsignedLargeIntegersPropertyType   109   && The value of the property is returned as a Vector object containing truncated non-negative Long elements.
#DEFINE VectorOfSinglesPropertyType   110   && The value of the property is a Vector object containing Single elements.
#DEFINE VectorOfDoublesPropertyType   111   && The value of the property is a Vector object containing Double elements.
#DEFINE VectorOfCurrenciesPropertyType   112   && The value of the property is a Vector object containing Currency elements.
#DEFINE VectorOfDatesPropertyType   113   && The value of the property is a Vector object containing Date elements.
#DEFINE VectorOfFileTimesPropertyType   114   && The value of the property is returned as a Vector object containing Date elements.
#DEFINE VectorOfClassIDsPropertyType   115   && The value of the property is returned as a Vector object containing String elements.
#DEFINE VectorOfStringsPropertyType   116   && The value of the property is a Vector object containing String elements.
#DEFINE VectorOfVariantsPropertyType   119   && The value of the property is a Vector object containing Variant elements.
#DEFINE UndefinedImagePropertyType   1000   && The value of the image property is undefined returned as a Byte.
#DEFINE ByteImagePropertyType   1001   && The value of the image property is a Byte.
#DEFINE StringImagePropertyType   1002   && The value of the image property is a String.
#DEFINE UnsignedIntegerImagePropertyType   1003   && The value of the image property is returned as a non-negative Integer.
#DEFINE LongImagePropertyType   1004   && The value of the image property is a Long.
#DEFINE UnsignedLongImagePropertyType   1005   && The value of the image property is returned as a non-negative Long.
#DEFINE RationalImagePropertyType   1006   && The value of the image property is returned as a Rational Object.
#DEFINE UnsignedRationalImagePropertyType   1007   && The value of the image property is returned as a Rational Object.
#DEFINE VectorOfUndefinedImagePropertyType   1100   && The value of the image property is returned as a Vector object containing Byte elements.
#DEFINE VectorOfBytesImagePropertyType   1101   && The value of the image property is a Vector object containing Byte elements.
#DEFINE VectorOfUnsignedIntegersImagePropertyType   1102   && The value of the image property is returned as a Vector object containing Integer elements.
#DEFINE VectorOfLongsImagePropertyType   1103   && The value of the image property is a Vector object containing Long elements.
#DEFINE VectorOfUnsignedLongsImagePropertyType   1104   && The value of the image property is returned as a Vector object containing Long elements.
#DEFINE VectorOfRationalsImagePropertyType   1105   && The value of the image property is returned as a Vector object containing Rational object elements.
#DEFINE VectorOfUnsignedRationalsImagePropertyType   1106   && The value of the image property is returned as a Vector object containing Rational object elements.
#DEFINE NotificationEvent   1   && Indicates that the DeviceEvent is intended to notify an application that is already running that this event has occurred.
#DEFINE ActionEvent   2   && Indicates that the DeviceEvent can, if necessary, launch an application if this event occurs.
#DEFINE UnspecifiedIntent   0   && No intent specified.
#DEFINE ColorIntent   1   && The image is a color illustration.
#DEFINE GrayscaleIntent   2   && The image is grayscale data.
#DEFINE TextIntent   4   && The image is a text image such as a fax or scanned document.
#DEFINE MinimizeSize   65536   && Use a lower quality scan to minimize the size of the file that contains the image.
#DEFINE MaximizeQuality   131072   && Use a higher quality scan to maximize the quality of the image.
