LOCAL loStationInfo AS "XML Web Service"
* LOCAL loStationInfo AS "MSSOAP.SoapClient30"
* Do not remove or alter following line. It is used to support IntelliSense for your XML Web service.
*__VFPWSDef__: loStationInfo = http://live.capeclear.com/ccx/GlobalWeather?wsdl , GlobalWeather , StationInfo
LOCAL loException, lcErrorMsg, loWSHandler
TRY
            loWSHandler = NEWOBJECT("WSHandler",IIF(VERSION(2)=0,"",HOME()+"FFC\")+"_ws3client.vcx")
            loStationInfo = loWSHandler.SetupClient("http://live.capeclear.com/ccx/GlobalWeather?wsdl", "GlobalWeather", "StationInfo")
            * Call your XML Web service here.  ex: leResult = loStationInfo.SomeMethod()
            
CATCH TO loException
            lcErrorMsg="Error: "+TRANSFORM(loException.Errorno)+" - "+loException.Message
            DO CASE
            CASE VARTYPE(loStationInfo)#"O"
                        * Handle SOAP error connecting to web service
            CASE !EMPTY(loStationInfo.FaultCode)
                        * Handle SOAP error calling method
                        lcErrorMsg=lcErrorMsg+CHR(13)+loStationInfo.Detail
            OTHERWISE
                        * Handle other error
            ENDCASE
            * Use for debugging purposes
            MESSAGEBOX(lcErrorMsg)
FINALLY
ENDTRY
