CLEAR
Local loGlobalWeather As "XML Web Service"
* LOCAL loGlobalWeather AS "MSSOAP.SoapClient30"
* Do not remove or alter following line. It is used to support IntelliSense for your XML Web service.
*__VFPWSDef__: loGlobalWeather = http://www.webservicex.net/globalweather.asmx?WSDL , GlobalWeather , GlobalWeatherSoap
Local loException, lcErrorMsg, loWSHandler
Try
   loWSHandler = Newobject("WSHandler",Iif(Version(2)=0,"",Home()+"FFC\")+"_ws3client.vcx")
   loGlobalWeather = loWSHandler.SetupClient("http://www.webservicex.net/globalweather.asmx?WSDL", "GlobalWeather", "GlobalWeatherSoap")
   * Call your XML Web service here.  ex: leResult = loGlobalWeather.SomeMethod()
   leResult=loGlobalWeather.GetWeather([St. Peterburg],[Russia])
   loXMLDom=Createobject("Microsoft.XMLDom")
   llLoad=loXMLDom.LoadXML(leResult)
   If llLoad
      loDataNodes=loXMLDom.childNodes.Item(1).childNodes
      For Each loNode In loDataNodes
         ? loNode.nodeName +": "
         ?? loNode.text
      Next
   Else
      Messagebox("      !",16,"   ")
   Endif


Catch To loException
   lcErrorMsg="Error: "+Transform(loException.ErrorNo)+" - "+loException.Message
   Do Case
      Case Vartype(loGlobalWeather)#"O"
         * Handle SOAP error connecting to web service
      Case !Empty(loGlobalWeather.FaultCode)
         * Handle SOAP error calling method
         lcErrorMsg=lcErrorMsg+Chr(13)+loGlobalWeather.Detail
      Otherwise
         * Handle other error
   Endcase
   * Use for debugging purposes
   Messagebox(lcErrorMsg)
Finally
Endtry
