Clear
Set Procedure To Sys(16)
Local loXMLDom As MSXML2.DOMDocument,;
   lcURL As String,;
   leException As Exception,;
   loNode As MSXML2.IXMLDOMNode,;
   lnRootChildNodes As Integer,;
   lcSyntax As String
*
lcResult=""
lcURL="http://www.js-software.eu/Alcometer.asmx?wsdl"
lcSyntax=""
loXMLDom=Createobject("MSXML2.DOMDocument.3.0")
loXMLDom.Async=.F.
If !loXMLDom.Load(lcURL)
   =Messagebox(;
      "  XML    URL",;
      48,;
      "  ";
      )
   Return
Endif
If (loXMLDom.parseError.errorCode <> 0) Then
   Local loError
   loError=loXMLDom.parseError
   =Messagebox(;
      "     :"+Chr(13)+;
      loError.reason,;
      48,;
      "   ";
      )
   Return
Endif

*!*<wsdl:types>
*!*<s:schema elementFormDefault="qualified" targetNamespace="http://www.js-software.eu/">
*!*   <s:element name="GetChanceToDrive">
*!*      <s:complexType>
*!*        <s:sequence>
*!*            <s:element minOccurs="1" maxOccurs="1" name="BottlesBefore" type="s:short"/>
*!*            <s:element minOccurs="1" maxOccurs="1" name="BottlesAfter"  type="s:short"/>
*!*        </s:sequence>
*!*      </s:complexType>
*!*   </s:element>
*!*   <s:element name="GetChanceToDriveResponse">
*!*      <s:complexType>
*!*        <s:sequence>
*!*           <s:element minOccurs="0" maxOccurs="1" name="GetChanceToDriveResult" type="s:string"/>
*!*        </s:sequence>
*!*      </s:complexType>
*!*   </s:element>
*!*</s:schema>
*!*</wsdl:types>

Try
   loXMLDom.setProperty(;
      "SelectionNamespaces",;
      [xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/"] ;
      )

   If loXMLDom.getProperty("SelectionLanguage")="XPath"
      loXMLDom.setProperty(;
         "SelectionLanguage",;
         "XSLPattern";
         )
   Endif

   *!*      loNodeList=loXMLDom.documentElement.selectNodes([.//wsdl:types//s:element/@name])
   loNodeList=loXMLDom.documentElement.selectNodes([./wsdl:types//s:element/])
   loNodeList2=loXMLDom.documentElement.selectNodes([./wsdl:types//s:element/@type])
   For Each loNode In loNodeList
      If loNode.Attributes.Length=1
         If (!"response" $ Lower(loNode.Attributes.getNamedItem("name").Text))
            lcSyntax=loNode.Attributes.getNamedItem("name").Text
            lcParameters=[(]+udf_GetTypes(loNode)+[)]
            lcSyntax=lcSyntax+lcParameters
         Endif
         If ("response" $ Lower(loNode.Attributes.getNamedItem("name").Text))
            lcResult=""
            lcName=Strtran(loNode.Attributes.getNamedItem("name").Text,[Response],[Result])
            lcSuffix=udf_GetTypes(loNode)
            lcSuffix=Strtran(lcSuffix,lcName,[])
            lcSyntax=lcSyntax+lcSuffix
         Endif
      Endif

   Next
Catch To leException
   =Messagebox(;
      ": "+leException.Message+Chr(13)+;
      leException.LineContents,;
      48,;
      "  ";
      )
   Return
Endtry
? lcSyntax

Function udf_GetTypes(lpoNode)
Local loCurrentNode As MSXML2.IXMLDOMNode
If lpoNode.Attributes.Length<4
   loCurrentNode=lpoNode.firstChild
   udf_GetTypes(loCurrentNode)
Else
   Do While .T.
      lcResult=lcResult+lpoNode.Attributes.getNamedItem("name").Text +[ As ]
      lcType=Strtran(lpoNode.Attributes.getNamedItem("type").Text,[s:],'')
      Do Case
         Case lcType="short"
            lcType="Integer"
      Endcase
      lcResult=lcResult+lcType
      If ! Isnull(lpoNode.NextSibling)
         lpoNode=lpoNode.NextSibling
         lcResult=lcResult+[,]
      Else
         Exit
      Endif

   Enddo
Endif
Return lcResult
Endfunc
Return
