#Define crlf   Chr(13)+Chr(10)
Clear
Local leException As Exception

* Registers XML Web service for consumption in VFP
Local i, j, lcMethodStr,lcSyntax,lcTips2Str, lcWSMLGTM
Local lcWSName,lcServicePort, lcService, lcPort, lcServiceDoc
Local lcWSDL,lcWSML,lcID,ldDateTime,lnSaveArea, loXMLDOM, lcClass
Local oGen,loParts,loEnumParts,loMethod,loEnumMethods,loPort,loEnumPorts,loService,loEnumServices
Local lcDescription, lcDocXPath, loNodes, lcMethodStr2, lFailXPath, lcGetType

Store 0 To loParts,loEnumParts,loMethod,loEnumMethods,loPort,loEnumPorts,loService,loEnumServices
Store "" To lcURI,cMethodStr,lcSyntax
Store "" To lcWSDL_XML, lcWSML_XML, lcWSMLGTM

Local ;
   loXMLDOM As MSXML2.DOMDocument.6.0,;
   lcURL As String, ;
   lcXMLSource As String,;
   loWSDLReader As MSSOAP.WSDLReader30,;
   loEnumeratorServices As Object,;
   loServiceName As Object,;
   loPortName As Object,;
   loMethodName As Object,;
   loEnumeratorMethodParts As Object,;
   loMethodParts As Object,;
   lcURL As String,;
   lcDescription as String,;
   lcXML as String
   
   
loEnumeratorServices=.Null.
loServiceName=.Null.
loPortName=.Null.
loMethodName=.Null.
loEnumeratorMethodParts=.Null.
loMethodParts=.Null.

*!*   lcURL="http:\\www.js-software.eu\Alcometer.asmx?wsdl"
lcURL="http://www.webservicex.net/globalweather.asmx?WSDL"
*lcURL="http://localhost/vfp_service.asmx?wsdl"
loXMLDOM=Createobject("MSXML2.DOMDocument.6.0")
loXMLDOM.Async=.F.
If !loXMLDOM.Load(lcURL)
   =Messagebox(;
      "  XML    URL",;
      48,;
      "  ";
      )
   Return
Endif
IF EMPTY(loXMLDOM.xml)
   =Messagebox(;
      " URL   WEB ",;
      48,;
      "   WEB ";
      )
   Return
Endif

If (loXMLDOM.parseError.errorCode <> 0) Then
   Local loError
   loError=loXMLDOM.parseError
   =Messagebox(;
      "     :"+Chr(13)+;
      loError.reason,;
      48,;
      "   ";
      )
   Return
Endif
lcXML=loXMLDOM.xml
Try
   loWSDLReader = Createobjectex("MSSOAP.WSDLReader30","","")
   loWSDLReader.Load(lcXML,"") 
   loWSDLReader.GetSoapServices(@loEnumeratorServices)
   Do While .T.
      loEnumeratorServices.Next(1,@loServiceName,1)
      If Vartype(loServiceName)!=[O]
         Exit
      Endif
      loEnumPorts=0
      loServiceName.GetSoapPorts(@loEnumPorts)
      Do While .T.
         loEnumPorts.Next(1,@loPortName,1)
         If Vartype(loPortName)!=[O]
            Exit
         Endif
         lcSyntax=""
         lcMethodStr=""
         lcMethodStr2=""

         * Get Methods
         loPortName.GetSoapOperations(@loEnumMethods)
         Do While .T.
            Store 0 To loMethodName,loEnumeratorMethodParts,loMethodParts
            loEnumMethods.Next(1,@loMethodName,1)
            If Vartype(loMethodName)#[O]
               Exit
            Endif
            * Get method name
            lcMethodStr = lcMethodStr + loMethodName.Name + crlf
            * Get documentation if any (need to use XPATH since STK3 doesn't support this)
            lcDescription=""
            Try
               lcDocXPath = "//wsdl:portType[@name='" + lcServicePort + "']/wsdl:operation[@name='" + loMethodName.Name + "']/wsdl:documentation"
               loNodes = loXMLDOM.selectNodes(lcDocXPath)
               If loNodes.Length>0
                  lcDescription = loNodes.Item(0).Text
                  ? lcDescription
               Endif
            Catch
            Endtry
            lcMethodStr2 = lcMethodStr2 + loMethodName.Name + " " + lcDescription + crlf
            loMethodName.GetOperationParts(@loEnumeratorMethodParts)
            lcTips2Str = ""
            lcRetType = "VOID"
            Do While .T.
               * Get parms
               loMethodParts = 0
               loEnumeratorMethodParts.Next(1,@loMethodParts,1)
               If Vartype(loMethodParts)#"O"
                  Exit
               Endif

               * Check if parameter or return type is complex object
               If Empty(loMethodParts.elementType) And Vartype(loMethodParts.SchemaNode)="O"
                  If Atc(":schema", loMethodParts.SchemaNode.XML)#0
                     lcGetType = "Dataset"
                  Else
                     lcGetType = "XMLDOMNodeList"
                  Endif
               Else
                  lcGetType = loMethodParts.elementType
               Endif

               If loMethodParts.parameterOrder = -1  &&check for return value
                  lcRetType = lcGetType
               Else
                  lcTips2Str = lcTips2Str + loMethodParts.elementName + " AS "
                  lcTips2Str = lcTips2Str + lcGetType
                  If loMethodParts.IsInput = 1   &&byref call
                     lcTips2Str = lcTips2Str + " @"
                  Endif
                  lcTips2Str = lcTips2Str + ", "
               Endif
            Enddo
            lcTips2Str=Alltrim(lcTips2Str)
            If Right(lcTips2Str,1)=","
               lcTips2Str = Substr(lcTips2Str,1,Len(lcTips2Str)-1)
            Endif
            lcSyntax = lcSyntax + loMethodName.Name + "(" + lcTips2Str + ")"
            lcSyntax = lcSyntax + " AS " + lcRetType + crlf
         Enddo   &&SoapOperations (Methods)
         loEnumeratorMethodParts = 0
         loMethodParts = 0
         loEnumMethods = 0
         loMethodName = 0
         loPortName = 0
      Enddo   &&Ports
      loEnumPorts = 0
      loServiceName = 0
   Enddo   &&Service
Catch To leException
   =Messagebox(;
      ": "+leException.Message+Chr(13)+;
      leException.LineContents,;
      48,;
      "  ";
      )
   Return
Endtry
? lcSyntax
? lcDescription
