Local loFSO As Scripting.FileSystemObject,;
   loText As Object
Local Array arColors[10]
arColors[1]="DarkViolet"
arColors[2]="DeepPink"
arColors[3]="FireBrick"
arColors[4]="ForestGreen"
arColors[5]="Indigo"
arColors[6]="DeepSkyBlue"
arColors[7]="Orange"
arColors[8]="Yellow"
arColors[9]="DarkCyan"
arColors[10]="Khaki"

loFSO=Createobject("Scripting.FileSystemObject")
loText=loFSO.CreateTextFile("C:\JSVFPBook\Examples\Glava7\northwind.xaml",.T.,.T.)
loText.WriteLine(;
   [<Canvas xmlns="http://schemas.microsoft.com/client/2007" xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml">];
   )
Local lnScale, lnGraphWidth, lnLegendShiftFromChart
lnGraphWidth=25
lnLegendShiftFromChart=20

Select Max(ProductSales) From Northwind!Sales_by_Category Into Array arMV
lnScale=400/arMV
Select Top 10 ProductSales*lnScale As cHeight, ;
   400 As cTop, ;
   200 As cLeft, ;
   lnGraphWidth As cWidth, ;
   5 As RadiusX,;
   5 As RadiusY, ;
   "Black" As Stroke,;
   1 As STickness,;
   SPACE(20) As oFill,;
   Productname ;
   FROM Northwind!Sales_by_Category Into Cursor PS2SL ;
   ORDER By ProductSales Desc NOFILTER Readwrite
For lni=1 To Reccount("PS2SL")
   Replace Next 1 cLeft With lni*lnGraphWidth+20
   Replace Next 1 oFill With arColors[lni]
   Skip In PS2SL
Next
Select Max(cLeft) From PS2SL Into Array arLegendLeft
lnLegendStarts=arLegendLeft+lnGraphWidth+lnLegendShiftFromChart
Select PS2SL
Go Top
Set Textmerge On
For lni=1 To Reccount("PS2SL")
   TEXT TO lcRestangles noshow
<Rectangle Height="<<cHeight>>" Canvas.Left="<<cLeft>>" Canvas.Top="<<cTop>>" Width="<<cWidth>>" RadiusX="<<RadiusX>>" RadiusY="<<RadiusY>>" Stroke="<<Stroke>>" StrokeThickness="<<STickness>>" Fill="<<oFill>>">
<Rectangle.RenderTransform>
<RotateTransform Angle="180" />
</Rectangle.RenderTransform>
</Rectangle>
<TextBlock Text="<<LTRIM(STR(lni))+SPACE(2)+Productname>>" Canvas.Left="<<lnLegendStarts>>" Canvas.Top="<<10+lni*25>>" FontSize="12" FontFamily="Arial" Foreground="<<oFill>>">
</TextBlock>
   ENDTEXT
   loText.WriteLine(lcRestangles)
   Skip In PS2SL
Next
Set Textmerge Off
loText.WriteLine([</Canvas>])
loText.Close

Local loIE As InternetExplorer.Application

loIE=Createobject("InternetExplorer.Application")
loIE.Navigate("file:///C:/JSVFPBook/Examples/Glava7/graph.html")
Do While loIE.ReadyState !=4
   DoEvents
Enddo
loIE.Visible=.T.
