Define Class vfpBizObject As Session OlePublic
   Protected oMTX, oContext
   oMTX = Null
   oContext = Null

   Protected Procedure Cleanup
      This.oContext = Null
      This.oMTX = Null
   Endproc

   Procedure Destroy
      This.Cleanup()
   Endproc

   Procedure CommitTransaction()
      If Vartype(This.oContext) = "O"
         This.oContext.SetComplete()
      Endif
      This.Cleanup()
   Endproc

   Procedure AbortTransaction()
      If Vartype(This.oContext) = "O"
         This.oContext.SetAbort()
      Endif
      This.Cleanup()
   Endproc

   Procedure InsertData(lpcXML)
      Local loWorker, llReturnValue
      llReturnValue = .F.
      This.oMTX      = Createobject("MTXAS.APPSERVER.1")
      This.oContext = This.oMTX.GetObjectContext()
      loWorker        = Createobject("crmobjects.vfpWorker")
      llReturnValue  = loWorker.InsertData(lpcXML)
      If !llReturnValue
         This.AbortData()
      ENDIF
      This.CommitTransaction()
      Return llReturnValue
   Endproc
Enddefine

