Set Procedure To Sys(16)
Local ;
   lcFolderToStart As String,;
   llFoldersTableFilled As Boolean,;
   lcMessageSuccess As String,;
   lcMessageError As String,;
   lcMBTitle As String,;
   llFoldersTableFilled As Boolean

lcFolderToExaminate="C:\JSVFPBook\"
lcMessageSuccess="  !"
lcMessageError="     !"
lcMessageSE=;
   "       !"+Chr(13)+;
   "   ."+Chr(13)+;
   "     !"

lcMBTitle="    "
lcFoldersDBF="C:\JSVFPBook\Examples\Glava9\myfolders.dbf"
lcFoldersTable="myfolders"


loFSO = Createobject('Scripting.FileSystemObject')
If !loFSO.FileExists(lcFoldersDBF)
   Create Table  (lcFoldersDBF)(folderid C(12),foldername C(64),dcreated D)
Else
   Use (lcFoldersDBF) Alias (lcFoldersTable)
Endif

llFoldersTableFilled = udf_FillFoldersTable(lcFolderToExaminate)
If !llFoldersTableFilled
   =Messagebox(lcMessageError,0+16,lcMBTitle)
Else
   =Messagebox(lcMessageSuccess ,0+64,lcMBTitle)
Endif
Browse Nowait
Return

********************************************************************************
*!*   First of all - save information about root folder in folders table
********************************************************************************
Procedure udf_FillFoldersTable
Lparameters lcFolderToStart

loInitialFolder=loFSO.GetFolder(lcFolderToStart)
lnFolderFieldSize = Fsize ( "FOLDERNAME", lcFoldersTable )

If Len(lcFolderToStart) > lnFolderFieldSize
   udf_ResizeFolderField ( Len ( lcFolderToStart ) +1 )
   lnFolderFieldSize = Len(lcFolderToStart)
Endif

lcFolderID=[FO]+Sys(2015)

Insert Into (lcFoldersTable) ;
   (folderid ,foldername, dcreated) ;
   VALUES (lcFolderID, Addbs(lcFolderToStart), loInitialFolder.DateCreated)

loSubfolders  = loInitialFolder.Subfolders
lnFolders     = loSubfolders.Count

If lnFolders > 0
   For Each loRSubFolder In loSubfolders
      lnLength=Len(lcFolderToStart+Addbs(loRSubFolder.Name))+1
      If lnLength>255
         =Messagebox(lcMessageSE,0+16,lcMBTitle)
         Return
      Endif

      If lnLength > lnFolderFieldSize
         udf_ResizeFolderField ( Len(loRSubFolder.Name)+1 )
         lnFolderFieldSize = Len(loRSubFolder.Name)+1
      Endif

      lcFolderID=[FO]+Sys(2015)
      Insert Into (lcFoldersTable) ;
         (folderid, foldername, dcreated) ;
         VALUES (lcFolderID, lcFolderToStart+Addbs(loRSubFolder.Name), loRSubFolder.DateCreated)
   Endfor
Endif
lnPointer = 2
Select (lcFoldersTable)
Go lnPointer
Do While .T.
   lcFlowFolder  = Alltrim(foldername)
   loFCollection = loFSO.GetFolder(lcFlowFolder)
   loSubfolders  = loFCollection.Subfolders
   lnFolders     = loSubfolders.Count

   If lnFolders > 0
      For Each loRSubFolder In loSubfolders
         lnLength=Len(lcFlowFolder+Addbs(loRSubFolder.Name))+1
         If lnLength>255
            =Messagebox(lcMessageSE,0+16,lcMBTitle)
            Return
         Endif
         If  lnLength> lnFolderFieldSize
            udf_ResizeFolderField ( Len(lcFlowFolder + Addbs(loRSubFolder.Name))+1 )
            lnFolderFieldSize = Len(lcFlowFolder + loRSubFolder.Name)+1
         Endif
         lcFolderID=[FO]+Sys(2015)
         Insert Into (lcFoldersTable) ;
            (folderid, foldername, dcreated) ;
            VALUES (lcFolderID, lcFlowFolder+Addbs(loRSubFolder.Name), loRSubFolder.DateCreated)
      Endfor
   Endif
   lnPointer = lnPointer+1
   If lnPointer > Reccount(lcFoldersTable)
      Exit
   Else
      Select (lcFoldersTable)
      Go lnPointer
   Endif
Enddo
Flush

Procedure udf_ResizeFolderField
Lparameters lpnFieldLenght
Local lcMessage
lcMessage = "Resizing field of the folder name to fit a long folder name!"
Wait lcMessage Window Nowait
Alter Table (lcFoldersTable) Alter foldername C(lpnFieldLenght)
Wait Clear
Endproc
