*  CURSORTOXML,  XMLAdapter        
*  XML  . 
* ,   XMLAdapter + XPath       .   ,    XML   .         .    Character . 

* : 

  
  CLOSE TABLES ALL   
  CLEAR   
  SET MEMOWIDTH TO 100  
    
  ? "Read XML"  
    
  TEXT TO cXML NOSHOW  
  <?xml version = "1.0" encoding="Windows-1251" standalone="yes"?>  
    <tree>    
      <products>    
        <product>    
          <products_id>1</products_id>    
          <products_name>TV-tuner</products_name>    
          <products_quantity>0</products_quantity>    
          <products_price>326.0000</products_price>    
          <products_date_available>0000-00-00 00:00:00</products_date_available>    
          <products_status>1</products_status>    
          <categories_id>107</categories_id>    
        </product>    
      </products>    
    </tree>  
  ENDTEXT  
    
  CREATE CURSOR product Codepage=1251( ;  
  products_id I, ;  
  products_name C(20), ;  
  products_quantity I, ;  
  products_price Y, ;  
  products_date_available c(19), ;  
  products_status I, ;  
  categories_id I ;  
  )  
    
  LOCAL oXA as XMLAdapter, oXT as XMLTable  
  oXA=CREATEOBJECT("XMLAdapter")  
    
  oXA.LoadXML(cXML,.F.)  
  oXA.AddTableSchema("product",.T.,STRCONV("product",5))  
    
  oXT=oXA.Tables(1)  
  oXT.ToCursor(.T.)  
    
  SELECT product  
  LIST  
  ?  
  ? "Write XML"  
  ?  
 * Use additional table with one record  
 * and RELATION to the 'product' table to add   
 * <products> element enclosing all <product>  
 * elements  
  CREATE CURSOR products_helper Codepage=1251(f1 I)  
  INSERT INTO products_helper VALUES (1)  
    
 * one record in products_helper must be   
 * related to all records in product  
  SELECT product  
  INDEX ON 1 TAG helper  
    
  SELECT products_helper   
  SET RELATION TO f1 INTO product  
    
  oXA=CREATEOBJECT("XMLAdapter")  
    
  oXA.RespectCursorCP= .T.  
  oXA.RespectNesting=.T.  
  oXA.CodePage=1251  
  oXA.UseCodePage= .T.  
  oXA.XMLSchemaLocation=""  
    
  oXA.XMLName=STRCONV("tree",5)  
  oXT=oXA.AddTableSchema("products_helper",.T.,STRCONV("products",5))  
  oXT.Fields.Remove(1) && remove XMLField for f1, we don't want it in XML  
    
  oXA.AddTableSchema("product",.T.,STRCONV("product",5))  
    
  oXA.ToXML("cXML2","",.F.)  
  ?cXML2
