********************************************************************************
* Program...: start.prg
* Pattern...: Common_start_program
********************************************************************************
* Author....: Juri Shutenko
* Created...: 17.05.2008
* Modified..: 17.05.2008
* Copyright.: (c) 2007 JS-Software, Inc
* Compiler..: Visual FoxPro 09.00.0000.3504 for Windows
********************************************************************************


Set Procedure To Sys(16) Additive
Public go_Settings
Local ;
   lcAppPath As String,;
   lcAtomName As String,;
   lcApplicationName As String

lcAtomName='JS_Glava19_Atom'
lcApplicationName="Protected by atom"


lcGUIDForWindow="16AD4C2A-CA67-4648-A723-E49EA941C715"
go_Settings=Createobject('Empty')
AddProperty(go_Settings,'appPath',Addbs(Justpath(Sys(16))))
AddProperty(go_Settings,'atomName',lcAtomName)
ADDPROPERTY(go_Settings,'GUID_For_Window',"16AD4C2A-CA67-4648-A723-E49EA941C715")
lcAppPath=go_Settings.appPath
Set Default To &lcAppPath

On Error Do udp_ErrorHandler With ;
   ERROR( ), Message( ), Message(1), Program( ), Lineno( )
Do udp_DeclareDLL

********************************************************************************
*       
********************************************************************************
If udf_IsApplicationAlreadyRunning(go_Settings.atomName)
   =Messagebox(;
      [      ]+;
      ["]+lcApplicationName+["!],;
      0+16,;
      [!];
      )
   On Error
   Clear Dlls
   Clear All
   Quit
Endif
********************************************************************************
*   .
********************************************************************************

Do lcAppPath+"common.mpr"
AddProperty(go_Settings,'atom',GlobalAddAtom(go_Settings.atomName))
_Screen.Visible=.T.
_Screen.Caption=lcApplicationName
llSetResult=SetProp(_VFP.HWnd, lcGUIDForWindow, 1)
Read Events
=SetLastError(0)
=GlobalDeleteAtom(go_Settings.atom)
? GetLastError()
WAIT

On Error

Close All
Clear All
Quit


********************************************************************************
* Procedures and functions
********************************************************************************
Procedure udp_ErrorHandler
Lparameter merror, mess1, mess21, mprog, mlineno
=Messagebox(;
   'Error number: ' + Ltrim(Str(merror))+Chr(13)+;
   'Error message: ' + mess1 +Chr(13)+;
   'Line of code with error: ' + mess21 +Chr(13)+;
   'Line number of error: ' + Ltrim(Str(mlineno))+Chr(13)+;
   'Program with error: ' + mprog,;
   0+16,;
   "An error occurs in the program execution";
   )
Endproc

********************************************************************************
* Function udf_IsApplicationAlreadyRunning()
********************************************************************************
Function udf_IsApplicationAlreadyRunning()
Lparameters lpcAtomName
*!*	If _vfp.StartMode=0
*!*	   Return .F.
*!*	Endif
lpcAtomName=lpcAtomName+Chr(0)
Return GlobalFindAtom(lpcAtomName)!=0

********************************************************************************
* Procedure udp_DeclareDLL
********************************************************************************
Procedure udp_DeclareDLL
Declare Short GlobalAddAtom In win32api String
Declare Short GlobalDeleteAtom In win32api Integer
Declare Short GlobalFindAtom In win32api String
Declare Short GlobalGetAtomName In win32api;
   Integer  nAtom,;
   STRING @ lpBuffer,;
   INTEGER  nSize
Declare SetLastError In kernel32 Integer
Declare Integer GetLastError In kernel32
Declare Integer SetProp In User32 Integer HWnd, String lpString, Integer hData
Declare Integer GetProp In User32 Integer HWnd, String  lpString
Declare Integer RemovePropA In User32 Integer HWnd, String lpString
Endproc
