********************************************************************************
* Program...: start.prg
* Pattern...: Common_start_program
********************************************************************************
* Author....: Juri Shutenko
* Created...: 17.05.2008
* Modified..: 17.05.2008
* Copyright.: (c) 2007 JS-Software, Inc
* Compiler..: Visual FoxPro 09.00.0000.3504 for Windows
********************************************************************************
Set Procedure To Sys(16)
Do udp_DeclareDLL

Local ;
   lcGUIDForApplication As String,;
   lcGUIDForWindow As String,;
   lcApplicationName As String,;
   lvMutexCreated As Variant


lcGUIDForApplication="111DDEB1-F2E3-4C01-B70C-AC3F33A7D0B8"
lcGUIDForWindow="16AD4C2A-CA67-4648-A723-E49EA941C715"
lcApplicationName="Protect by mutex"

lvMutexCreated=udf_IsApplicationAlreadyRunning(lcGUIDForApplication)
If Vartype(lvMutexCreated)="L"
   =Messagebox(;
      [      ]+;
      ["]+lcApplicationName+["!],;
      0+16,;
      [!];
      )
   On Error
   Clear Dlls
   Clear All
   Quit
Endif

Public go_Settings
Local ;
   lcAppPath As String
go_Settings=Createobject('Empty')
AddProperty(go_Settings,'appPath',Addbs(Justpath(Sys(16))))
AddProperty(go_Settings,'mutexHandle',lvMutexCreated)

lcAppPath=go_Settings.appPath
Set Default To &lcAppPath

On Error Do udp_ErrorHandler With ;
   ERROR( ), Message( ), Message(1), Program( ), Lineno( )

Do lcAppPath+"common.mpr"
Read Events
On Error
Clear Dlls
Clear All
Quit

************************************************************
* Procedures and functions
************************************************************
Function udf_IsApplicationAlreadyRunning()
LPARAMETERS lpcMutexName
#Define ERROR_ALREADY_EXISTS  183
Local lnhMutex
lnhMutex = CreateMutex(0,1,lpcMutexName)
If GetLastError()= ERROR_ALREADY_EXISTS
   Return .T.
Else
   Return lnhMutex
Endif
Endfunc

Procedure udp_ErrorHandler
Lparameter merror, mess1, mess21, mprog, mlineno
=Messagebox(;
   'Error number: ' + Ltrim(Str(merror))+Chr(13)+;
   'Error message: ' + mess1 +Chr(13)+;
   'Line of code with error: ' + mess21 +Chr(13)+;
   'Line number of error: ' + Ltrim(Str(mlineno))+Chr(13)+;
   'Program with error: ' + mprog,;
   0+16,;
   "An error occurs in the program execution";
   )
Endproc

Procedure udp_DeclareDLL()

Declare Integer CreateMutex  In Win32API ;
   Integer lpMutexAttributes, ;
   Integer bInitialOwner, ;
   String lpName
Declare Integer GetLastError In Win32API
Declare Integer SetProp In User32 Integer HWnd, String lpString, Integer hData
Declare Integer BringWindowToTop In Win32API Integer HWnd
Declare Integer GetDesktopWindow In User32
Declare Integer GetProp In User32 Integer HWnd, String  lpString
Declare Integer GetWindow In User32 Integer HWnd, Integer uCmd
Declare Integer ShowWindow In Win32API AS ShowWindowA Integer HWnd, Integer nCmdShow
Declare Integer CloseHandle In Kernel32 Integer hObject
Endproc

Procedure udp_Shutdown()
Lparameters lpnShutdownType
On Shutdown
Do Case
   Case lpnShutdownType=-1
      *      
      If Pemstatus(_Screen,"MutexHandle",5)
         Declare Integer ReleaseMutex In Win32API Integer hMutex
         Declare Integer CloseHandle In Kernel32 Integer hObject
         ReleaseMutex(_Screen.MutexHandle)
         CloseHandle(_Screen.MutexHandle)
         Clear Dlls
      Endif
      Quit
Endcase
Endproc

