********************************************************************************
* Program...: start.prg
* Pattern...: Common_start_program
********************************************************************************
* Author....: Juri Shutenko
* Created...: 17.05.2008
* Modified..: 17.05.2008
* Copyright.: (c) 2007 JS-Software, Inc
* Compiler..: Visual FoxPro 09.00.0000.3504 for Windows
********************************************************************************
Set Step On

Set Procedure To Sys(16)
Do udp_DeclareDLL

Local ;
   lcGUIDForApplication As String,;
   lcGUIDForWindow As String

lcGUIDForApplication="111DDEB1-F2E3-4C01-B70C-AC3F33A7D0B8"
lcGUIDForWindow="16AD4C2A-CA67-4648-A723-E49EA941C715"

If udf_IsApplicationAlreadyRunning()

ENDIF

Public go_Settings
Local ;
   lcAppPath As String,;
   lcApplicationName As String,;
   lcGUIDForApplication As String,;
   lcGUIDForWindow As String
go_Settings=Createobject('Empty')
AddProperty(go_Settings,'appPath',Addbs(Justpath(Sys(16))))
lcAppPath=go_Settings.appPath
Set Default To &lcAppPath

lcApplicationName="Protected by Mutex"

On Error Do udp_ErrorHandler With ;
   ERROR( ), Message( ), Message(1), Program( ), Lineno( )






On Shutdown Do udp_Shutdown
...
*     
...


Function udf_IsApplicationAlreadyRunning()

#Define ERROR_ALREADY_EXISTS  183
#Define GW_CHILD                5
#Define GW_HWNDNEXT             2
#Define SW_MAXIMIZE             3
#Define SW_NORMAL               1

Local lnhMutex, lnHwnd, llReturn


lnhMutex = CreateMutex(0, 1, lcGUIDForMutex)
If GetLastError()= ERROR_ALREADY_EXISTS
   Do udp_DeclareWindowsAPI()
   llReturn = .T.
   lnHwnd = GetWindow(GetDesktopWindow(), GW_CHILD)
   Do While lnHwnd != 0 && loop through all windows
      If GetProp(lnHwnd, lcGUIDForWindow) = 1
         BringWindowToTop(lnHwnd)
         ShowWindow(lnHwnd,SW_NORMAL)
         *     
         * ShowWindow(lnHwnd,SW_MAXIMIZE)
         llReturn = .T.
         Exit
      Endif
      lnHwnd = GetWindow(lnHwnd, GW_HWNDNEXT)
   Enddo
   CloseHandle(lnHwnd)
   CloseHandle(lnhMutex)
   Clear Dlls "BringWindowToTop", "GetDesktopWindow", ;
      "GetProp", "GetWindow", "ShowWindow", ;
      "CloseHandle"
Else
   =SetProp(_vfp.HWnd, lcGUIDForWindow, 1)
   _Screen.AddProperty("MutexHandle",lnhMutex)
   llReturn = .F.
Endif
Clear Dlls "CreateMutex", "GetLastError", "SetProp"
Return (llReturn)
Endfunc

Procedure udp_DeclareDll()

Declare Integer CreateMutex  In Win32API ;
   Integer lpMutexAttributes, ;
   Integer bInitialOwner, ;
   String lpName
Declare Integer GetLastError In Win32API
Declare Integer SetProp In User32 Integer HWnd, String lpString, Integer hData
Declare Integer BringWindowToTop In Win32API Integer HWnd
Declare Integer GetDesktopWindow In User32
Declare Integer GetProp In User32 Integer HWnd, String  lpString
Declare Integer GetWindow In User32 Integer HWnd, Integer uCmd
Declare Integer ShowWindowA In Win32API Integer HWnd, Integer nCmdShow
Declare Integer CloseHandle In Kernel32 Integer hObject
Endproc

Procedure udp_Shutdown()
LPARAMETERS lpnShutdownType
On Shutdown
DO CASE
CASE lpnShutdownType=-1
*      
If Pemstatus(_Screen,"MutexHandle",5)
   Declare Integer ReleaseMutex In Win32API Integer hMutex
   Declare Integer CloseHandle In Kernel32 Integer hObject
   ReleaseMutex(_Screen.MutexHandle)
   CloseHandle(_Screen.MutexHandle)
   Clear Dlls 
   Endif
Quit
Endproc

