********************************************************************************
* Program...: start.prg
* Pattern...: Common_start_program
********************************************************************************
* Author....: Juri Shutenko
* Created...: 17.05.2008
* Modified..: 17.05.2008
* Copyright.: (c) 2007 JS-Software, Inc
* Compiler..: Visual FoxPro 09.00.0000.3504 for Windows
********************************************************************************
Set Procedure To Sys(16) Additive
Public go_Settings
Local ;
   lcAppPath As String,;
   lcApplicationName As String,;
   lcGUIDForWindow As String

lcApplicationName="Protected by window"
lcGUIDForWindow="16AD4C2A-CA67-4648-A723-E49EA941C715"
go_Settings=Createobject('Empty')
AddProperty(go_Settings,'appPath',Addbs(Justpath(Sys(16))))
AddProperty(go_Settings,'GUID_For_Window',lcGUIDForWindow)
lcAppPath=go_Settings.appPath
Set Default To &lcAppPath

On Error Do udp_ErrorHandler With ;
   ERROR( ), Message( ), Message(1), Program( ), Lineno( )
Do udp_DeclareDLL

********************************************************************************
*       
********************************************************************************
If udf_IsApplicationAlreadyRunning(lcGUIDForWindow)
   =Messagebox(;
      [      ]+;
      ["]+lcApplicationName+["!],;
      0+16,;
      [!];
      )
   On Error
   Clear Dlls
   Clear All
   Quit
Endif
********************************************************************************
*   .
********************************************************************************

Do lcAppPath+"common.mpr"
_Screen.Visible=.T.
_Screen.Caption=lcApplicationName
llSetResult=SetProp(_vfp.HWnd, lcGUIDForWindow, 1)
Read Events
= RemovePropA(_vfp.HWnd, lcGUIDForWindow)
On Error
Close All
Clear All
Quit


********************************************************************************
* Procedures and functions
********************************************************************************
Procedure udp_ErrorHandler
Lparameter merror, mess1, mess21, mprog, mlineno
=Messagebox(;
   'Error number: ' + Ltrim(Str(merror))+Chr(13)+;
   'Error message: ' + mess1 +Chr(13)+;
   'Line of code with error: ' + mess21 +Chr(13)+;
   'Line number of error: ' + Ltrim(Str(mlineno))+Chr(13)+;
   'Program with error: ' + mprog,;
   0+16,;
   "An error occurs in the program execution";
   )
Endproc

********************************************************************************
* Function udf_IsApplicationAlreadyRunning()
********************************************************************************
Function udf_IsApplicationAlreadyRunning()
Lparameters lpcGUIDForWindow
Local ;
   llWindowFound As Boolean,;
   lnhWndNext As Integer
#Define GW_HWNDNEXT 2
#Define GW_CHILD    5
#Define SW_NORMAL   1


lnhWndNext = GetWindow(GetDesktopWindow(),GW_CHILD) && get the handel of the first window
* next loop through all windows for matching caption in the Title bar
* and part of the caption for application window
Do While lnhWndNext <> 0
   If IsWindowVisible(lnhWndNext)>0
      If GetProp(lnhWndNext, lpcGUIDForWindow) = 1
         llWindowFound=.T.
         BringWindowToTop(lnhWndNext)
         *SetForegroundWindow(lnhWndNext)
         ShowWindow(lnhWndNext,SW_NORMAL)
         Exit
      Endif
   Endif
   lnhWndNext = GetWindow(lnhWndNext,GW_HWNDNEXT)
Enddo
Return llWindowFound
Endfunc

********************************************************************************
* Procedure udp_DeclareDLL
********************************************************************************
Procedure udp_DeclareDLL
Declare Integer GetDesktopWindow In Win32API
Declare Integer GetWindow In Win32API Integer,Integer
Declare Integer IsWindowVisible In Win32API Integer
Declare Integer SetForegroundWindow In Win32API Long lnhWnd
Declare Integer BringWindowToTop In user32 Integer HWnd
Declare Long ShowWindow In Win32API Long, Long
Declare Integer GetProp In User32 Integer HWnd, String  lpString
Declare SetLastError In kernel32 Integer
Declare Integer GetLastError In kernel32
Declare Integer SetProp In User32 Integer HWnd, String lpString, Integer hData
Declare Integer GetProp In User32 Integer HWnd, String  lpString
Declare Integer RemovePropA In User32 Integer HWnd, String lpString
Endproc
