LOCAL loGlobalWeather AS "XML Web Service"
* LOCAL loGlobalWeather AS "MSSOAP.SoapClient30"
* Do not remove or alter following line. It is used to support IntelliSense for your XML Web service.
*__VFPWSDef__: loGlobalWeather = http://www.webservicex.net/globalweather.asmx?WSDL , GlobalWeather , GlobalWeatherSoap
LOCAL loException, lcErrorMsg, loWSHandler
TRY
   loWSHandler = NEWOBJECT("WSHandler",IIF(VERSION(2)=0,"",HOME()+"FFC\")+"_ws3client.vcx")
   loGlobalWeather = loWSHandler.SetupClient("http://www.webservicex.net/globalweather.asmx?WSDL", "GlobalWeather", "GlobalWeatherSoap")
   * Call your XML Web service here.  ex: leResult = loGlobalWeather.SomeMethod()
   leResult=loGlobalWeather.GetCitiesByCountry("Russia")
   =XMLTOCURSOR(leResult,"cities")
   ALTER TABLE "cities" DROP COLUMN country
LOCATE FOR "peter" $ LOWER(city)
IF FOUND()
   lcCiyOfInterest=city
   ? lcCiyOfInterest
ENDIF

CATCH TO loException
   lcErrorMsg="Error: "+TRANSFORM(loException.Errorno)+" - "+loException.Message
   DO CASE
   CASE VARTYPE(loGlobalWeather)#"O"
      * Handle SOAP error connecting to web service
   CASE !EMPTY(loGlobalWeather.FaultCode)
      * Handle SOAP error calling method
      lcErrorMsg=lcErrorMsg+CHR(13)+loGlobalWeather.Detail
   OTHERWISE
      * Handle other error
   ENDCASE
   * Use for debugging purposes
   MESSAGEBOX(lcErrorMsg)
FINALLY
ENDTRY
