External Array pLogRecord
Define Class vfpCompensator As Session OlePublic
   Protected oCrmLogControl
   oCrmLogControl = Null
   Implements ICrmCompensatorVariants In "comsvcs.dll"
   Procedure ICrmCompensatorVariants_SetLogControlVariants(pLogControl ;
         AS VARIANT) As VOID ;
         HELPSTRING "method SetLogControlVariants"
      Local lcTransactionUOW
      This.oCrmLogControl = pLogControl
   Endproc
   ***************************
   Procedure ICrmCompensatorVariants_PrepareRecordVariants(pLogRecord ;
         AS VARIANT) As LOGICAL ;
         HELPSTRING "method PrepareRecordVariants"
      * Setting This to .T. causes CommitRecordVariants not to get called
      Return .F.
   Endproc
   ***************************
   Procedure ICrmCompensatorVariants_BeginPrepareVariants() As VOID;
         HELPSTRING "method BeginPrepareVariants"
   Endproc
   ***************************
   Procedure ICrmCompensatorVariants_EndPrepareVariants() As LOGICAL;
         HELPSTRING "method EndPrepareVariants"
      * Vote on the outcome of the transaction. Return .F. to rollback
      Return .T.
   Endproc
   ***************************
   Procedure ICrmCompensatorVariants_AbortRecordVariants(pLogRecord ;
         AS VARIANT) As LOGICAL ;
         HELPSTRING "method AbortRecordVariants"
      * Code for aborting the transaction goes here
      Return .T.
   Endproc
   ***************************
   Procedure ICrmCompensatorVariants_CommitRecordVariants(pLogRecord ;
         AS VARIANT) As LOGICAL;
         HELPSTRING "method CommitRecordVariants"
      Local llReturnValue As LOGICAL, loException As Exception
      llReturnValue = .T.
      Try
         Xmltocursor(pLogRecord[1], "cCustomer")
         Set Exclusive Off
         Use C:\JSVFPBook\Data\Customers.dbf In 0
         Insert Into Customers (CustomerID, CompanyName, ContactName, ;
            Address, City, Region, PostalCode, Country, Phone) ;
            VALUES (cCustomer.CustID, cCustomer.CompName,;
            cCustomer.ContName, cCustomer.Address, cCustomer.City, ;
            cCustomer.State, cCustomer.Zip, ;
            cCustomer.Country, cCustomer.Phone)
      Catch To loException
         llReturnValue = .F.
      Finally
         Close Databases All
      Endtry
      Return llReturnValue
   Endproc
   ***************************
   Procedure ICrmCompensatorVariants_BeginCommitVariants(bRecovery ;
         AS LOGICAL) As VOID ;
         HELPSTRING "method BeginCommitVariants"
   Endproc
   ***************************
   Procedure ICrmCompensatorVariants_EndCommitVariants() As VOID;
         HELPSTRING "method EndCommitVariants"
   Endproc
   ***************************
   Procedure ICrmCompensatorVariants_BeginAbortVariants(bRecovery ;
         AS LOGICAL) As VOID;
         HELPSTRING "method BeginAbortVariants"
   Endproc
   ***************************
   Procedure ICrmCompensatorVariants_EndAbortVariants() As VOID;
         HELPSTRING "method EndAbortVariants"
   Endproc
Enddefine
